#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#*****************************************************************************
#
#                                   LOOPS
#
#*****************************************************************************

#%%
# tuple filled with arbitrary elements
my_tuple = (1, 2.0, 'text', list(), dict())

# for-loop over my_tuple with control variable 'el'
for el in my_tuple:
    msg = 'element: {}'.format(el)
    print(msg)



#%%
# tuple filled with arbitrary elements
my_tuple = (1, 2.0, 'text', list(), dict())

# for-loop over my_tuple with control variable 'i'
for i in range(len(my_tuple)):
    el = my_tuple[i]
    msg = 'element {}: {}'.format(i, el)
    print(msg)



#%%
# list filled with arbitrary elements
my_list = [1, 2.0, 'text', list(), dict()]

# for-loop over my_list with control variable 'i'
for i in range(len(my_list)):

    # update element with index i 
    my_list[i] = 'element {}: {}'.format(i, my_list[i])
    print(my_list[i])



#%%
# list filled with arbitrary elements
my_list = [1, 2.0, 'text', list(), dict()]

# for-loop over my_list with control variables 'i' and 'el'
for i, el in enumerate(my_list):
    # update element with index 
    my_list[i] = 'element {}: {}'.format(i,el)
    print('old: {}, new: {}'.format(el, my_list[i]))



#%%
# set filled with arbitrary elements
my_set = {1, 1, 1, 2.0, 'text'}

# for-loop over my_set with control variable 'el'
for el in my_set:
    msg = 'element: {}'.format(el)
    print(msg)



#%%
# dictionary filled with arbitrary elements
my_dict = {'key': 'value', 1: 'text', (1, 2) : 'text'}

# for-loop over keys of my_dict with control variable 'key'
for key in my_dict:
    val = my_dict[key]
    msg = 'key: {}, value: {}'.format(key, val)
    print(msg)

#%%
# dictionary filled with arbitrary elements
my_dict = {'key': 'value', 1: 'text', (1, 2) : 'text'}
# for-loop over items of my_dict with control variables 'key', 'val'
for key, val in my_dict.items():
    msg = 'key: {}, value: {}'.format(key, val)
    print(msg)



#%%
x=5
while x > 0:
    print(x)
    x -= 1 # shorthand for x = x - 1


#*****************************************************************************
#
#                                 FUNCTIONS
#
#*****************************************************************************


#%%
def myFirstFunction():
    print('this is my first function')

# call function
myFirstFunction()

# save return value in variable
hereComesNothing = myFirstFunction()



#%%
def findSubstringInStrings(stringCollection, pattern):
    occ = list()
    for i, s in enumerate(stringCollection):
        j = s.find(pattern)
        while j != -1:
            occ.append((i, j))
            j = s.find(pattern, j+1)
    return occ

myStringList = ['the rain in spain', 'ain\'t no sunshine', \
        'she was greeted with disdain']
occOfAin = findSubstringInStrings(myStringList, 'ain')


#*****************************************************************************
#
#                        CLASSES, MODULES & PACKAGES 
#
#*****************************************************************************


#%%
class Library:
    description = 'This is a Library'

    def __init__(self, name):
        # name the library
        self.name = name

        # create empty book storage on initialization
        self.storage = list()

    def addBook(self, book):
        self.storage.append(book)

    def getAllBooks(self):
        return tuple(self.storage)

myLib = Library('Bodleian Library')
myLib.addBook('The Art of Computer Programming (D. Knuth)')


#*****************************************************************************
#
#                      PROGRAMMING ERRORS & DEBUGGING
#
#*****************************************************************************


#%%
# dictionary filled with arbitrary elements
my_dict = {'key': 'value', 1: 'text', (1, 2) : 'text'}

# for-loop over keys of my_dict with control variable 'key'
for key in my_dict:
    my_dict[(key, 1, 2, 3)] = 'new element'



#%%
while True:
    try:
        x = int(input("Please enter a number: "))
        break
    except ValueError:
        print("Oops! That was no valid number. Try again...")



#%%
def myFunction(collection):
    if len(collection) == 0:
        raise RuntimeError("Invalid input: empty collection")
    # do something ..
    return

myFunction(list())



#%%
def myFunction(collection):
    assert len(collection) > 0, "Invalid input: empty collection"
    # do something ..
    return

myFunction(list())



#%%
# dictionary filled with arbitrary elements
my_dict = {'key': 'value', 1: 'text', (1, 2) : 'text'}

# invoke Python debugger
breakpoint()

# for-loop over keys of my_dict with control variable 'key'
for key in my_dict:
    my_dict[(key, 1, 2, 3)] = 'new element'

